#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum TypeSortField {
    #[serde(rename = "CREATED_AT")]
    CreatedAt,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl TypeSortField {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            TypeSortField::CreatedAt => "CREATED_AT",
            TypeSortField::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for TypeSortField {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for TypeSortField {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for TypeSortField {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<TypeSortField, conjure_object::plain::ParseEnumError> {
        match v {
            "CREATED_AT" => Ok(TypeSortField::CreatedAt),
            v => v.parse().map(|v| TypeSortField::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for TypeSortField {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<TypeSortField, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the TypeSortField enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
